/*-
 * Copyright (c) 2009 Jung-uk Kim <jkim@FreeBSD.org>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $FreeBSD$
 */

#ifndef _X86BIOS_MACHDEP_H_
#define	_X86BIOS_MACHDEP_H_

#if defined(__amd64__) || defined(__i386__)
#define	X86BIOS_NATIVE_PIO
#define	X86BIOS_NATIVE_IVT
#define	X86BIOS_NATIVE_RAM
#define	X86BIOS_NATIVE_ROM
#endif

#if defined(__ia64__)
#define	X86BIOS_NATIVE_PIO
#define	X86BIOS_NATIVE_ROM
#endif

#ifdef X86BIOS_NATIVE_PIO
#define	X86BIOS_INB(e, p)	inb(p)
#define	X86BIOS_INW(e, p)	inw(p)
#define	X86BIOS_INL(e, p)	inl(p)
#define	X86BIOS_OUTB(e, p, v)	outb(p, v)
#define	X86BIOS_OUTW(e, p, v)	outw(p, v)
#define	X86BIOS_OUTL(e, p, v)	outl(p, v)
#else
#define	X86BIOS_INB(e, p)	x86bios_halt_sys(e)
#define	X86BIOS_INW(e, p)	x86bios_halt_sys(e)
#define	X86BIOS_INL(e, p)	x86bios_halt_sys(e)
#define	X86BIOS_OUTB(e, p, v)	(void)x86bios_halt_sys(e)
#define	X86BIOS_OUTW(e, p, v)	(void)x86bios_halt_sys(e)
#define	X86BIOS_OUTL(e, p, v)	(void)x86bios_halt_sys(e)
#endif

#ifdef X86BIOS_NATIVE_RAM
#define	x86bios_ram_base	X86BIOS_RAM_BASE
#endif

#ifdef X86BIOS_NATIVE_ROM
#define	x86bios_rom_base	X86BIOS_ROM_BASE
#endif

#endif	/* !_X86BIOS_MACHDEP_H_ */
